import numpy as np
# from skimage.exposure import adjust_gamma, adjust_log, equalize_adapthist, adjust_sigmoid

def stretch(x, method='linear', param=None):

# all stretches assume x is in the interval [0, 1] and return a 
# transformation also in that interval. 

    if method == 'linear':
        return x

    if method == 'hyper':
        d = .02
        c = d * (1 + d - param)
        return (1 + c) * (x / (x + c))

    if method == 'log':
        #c = param * 100
        c = param * 200
        return np.log(c*x + 1) / np.log(c + 1)

    if method == 'asinh':
        c = param * 250
        return np.arcsinh(c*x) / np.arcsinh(c)

    if method == 'γ':
        gamma = param * 5 + 0.01 # to avoid div by zero
        return x ** (1 / gamma)

    if method == 'log γ':
        gamma = param * 5 + 0.01
        return ((np.log(x+1) - np.log(1)) / np.log(2))**(1/gamma)

    else:
        return x


# possible further methods

    #if method == 'CLAHE':
    #    return equalize_adapthist(x, kernel_size=round(100*p1))

    # if method == 'sinh':
    #    return sinh(x / p1) / sinh(1 / p1)

    # if method == 'sigmoid':
    #     cutoff = p1/3
    #     gain = params[2]
    #     return adjust_sigmoid(x, cutoff=cutoff, gain=gain)

    # return adjust_gamma(x, gamma)

    # if method == 'asinh_astropy':  
    #     return arcsinh(x / p1) / arcsinh(1 / p1)

    # if method == 'power':
    #     c = 0.2*(1 - p1)
    #     return (c**x - 1)/(c - 1)

