# wrapper for FileBrowser to fit current window size, select only directories and hide background

import os.path
from jocular.widgets.filebrowser import FileBrowser
from kivy.lang import Builder
from kivy.core.window import Window
from jocular.utils.utils import home_folder

Builder.load_string('''

<JFileBrowser>:
    canvas.before:
        Color:
            rgba: 0, 0, 0, 1
        Rectangle:
            pos: self.pos
            size: self.size
    pos: 0, 0
    size_hint: None, None
    dirselect: True
    select_string: 'Select'
''')

class JFileBrowser(FileBrowser):

    def __init__(self, **kwargs):
        self.filters = [self._isdir]
        super().__init__(**kwargs)
        self.favorites=[(home_folder(), 'Documents')]
        self.size = Window.size

    def _isdir(self, dirname, filename):
        return os.path.isdir(filename)
