# basic class to draw reticule

from kivy.properties import NumericProperty, BooleanProperty
from kivy.lang import Builder
from kivy.uix.widget import Widget

Builder.load_string('''

<Reticule>:
    canvas:
        Color: 
            rgba: app.highlight_color if root.show else self.disabled_color
        Line:
            circle: self.x, self.y, self.inner, 0, 360, 100
            width: self.thickness
        Line:
            circle: self.x, self.y, 3*self.inner, 0, 360, 100
            width: self.thickness
        Line:
            circle: self.x, self.y, 6*self.inner, 0, 360, 100
            width: self.thickness
        Line:
            points: self.x, self.y - self.inner, self.x, self.y - self.outer
            width: self.thickness
        Line:
            points: self.x, self.y + self.inner, self.x, self.y + self.outer
            width: self.thickness
        Line:
            points: self.x - self.outer, self.y, self.x - self.inner, self.y
            width: self.thickness
        Line:
            points: self.x + self.outer, self.y, self.x + self.inner, self.y
            width: self.thickness
    disabled_color: [0, 0, 0, 0]

''')

class Reticule(Widget):

    inner = NumericProperty(10)
    outer = NumericProperty(1)
    radius = NumericProperty(1)
    thickness = NumericProperty(1)
    show = BooleanProperty(False)
